from libcpp.map cimport map
from libcpp.pair cimport pair
from libcpp.vector cimport vector
from libcpp cimport bool
from libcpp.string cimport string


cdef extern from "Professor/ParamPoints.h" namespace "Professor":
    cdef cppclass ParamPoints:
        ParamPoints(const vector[ vector[double] ]&) except +


cdef extern from "Professor/Ipol.h" namespace "Professor":
    cdef cppclass Ipol:

        Ipol(const ParamPoints& p, const vector[double]&, int, const string&, double, bool) except +
        Ipol(const string&) except +

        string name() except +
        int order() except +
        int dim() except +

        const vector[double]& coeffs() except +
        double coeff(size_t) except +

        const ParamPoints& params() except +

        double value(const vector[double]&) except +

        string toString() except +
        string toString(const string&) except +

        void setParamLimits(const vector[double]&, const vector[double]&) except +
        void setMinParamVals(const vector[double]&) except +
        void setMaxParamVals(const vector[double]&) except +
